﻿Namespace System

	''' <summary> generische Exception mit genauen Daten über das fehler-werfende Objekt </summary>
	Public Class Exception(Of T) : Inherits Global.System.Exception

		''' <summary>
		''' stellt den Fehler-Werfer fürs Debuggen zur Verfügung
		''' </summary>
		Public ReadOnly Sender As T

		Public Sub New(sender As T, innerException As Exception, message As String)
			MyClass.New(innerException, message)
			Me.Sender = sender
		End Sub

		Public Sub New(innerException As Exception, message As String)
			MyBase.New(String.Concat(
				GetType(T).Name, "-Exception",
				If(String.IsNullOrEmpty(message), "", ": " & Environment.NewLine & message)), innerException)
		End Sub

	End Class

End Namespace
