﻿#Region "FileHeader"
#If False Then
DataParser fills sorted Strings into a AutoCompleteStringCollection, then hack it to get Access to the underlying Data-Array. In Effect DataParser needs no additional Memory and Array.BinarySearch is available for real rapidely figgure out the best Matches to a given User-Input.
After Parsing an Input DataParser provides several Informations about it:
 - FirstBestMatch: Note, several bestMatches are possible: the input "an" matches to "anoying" as well (or as bad) as to "another", but DataParser will choose the first one in Sort-Order: "another".
 - ValidInputLength: a valid input usually has no divergence to the bestMatch, in other words ValidInputLength is at input.Length. In the above sample ValidInputLength of "an" is at Position 2. The other hand the input "anormal" is invalid, and its ValidInputLength is at Position 3 (since the 'o' still matches).
 - SelectionStart: Dataparser propose it on parse, but the owning CoercingAutoCompletion-instance can change it.
 - NextValidKeys: A String lists the continue-options at SelectionStart-Positon: In the sample: ">ty<"

about the underlaying data-concept:
see sorted data as a matrix of chars. a valid input alway matches to one or more data-lines. this is modelled by the class-vars _FirstMatchPos and _LastMatchPos, which define the height of the (so i call it:) "option-range". Sample-data:
aabaejdie
abbceaeiw
abbcfesew
acaaewdce
baaesewsd
here the input "ab" would be in the optionrange of 1-2, and the right-exclusive bound, the "decision-column" is at positon 4. option-range-excerpt:
abbc
abbc
decision-column is 4, because at that position the user must decide, whether he will continue with "e" or with "f".
so the option-range is a rectangle of equal data-sections, who match to the input.
Wind-forward to the decision-column is possible, when the input is shorter than option-ranges width. in the sample you can wind forward up to pos 4, because the valid input for positions 2+3 ist predefined: it can only be "bc" - other options are not available.
#End If '-- Options, Imports
Imports System.Reflection
Imports System.Collections
#End Region 'FileHeader

Namespace System.Windows.Forms

   Partial Class CoercingAutoCompletion

      Private Class DataParser22

         Public FirstBestMatch As String
         Public ValidInputLength, SelectionStart As Integer
         Public WindForward As Boolean = True

         Private _FirstMatchPos, _LastMatchPos, _DecisionColumn As Integer
         Private _RawWords As Object()

         Public Sub Refill(autoSource As AutoCompleteStringCollection, texts As IEnumerable(Of String))
            autoSource.Clear()
            Dim txts = texts.ToArray
            Array.Sort(txts, StringComparer.OrdinalIgnoreCase)
            autoSource.AddRange(txts)
            Dim bf = BindingFlags.Instance Or BindingFlags.NonPublic
            Dim inf = GetType(AutoCompleteStringCollection).GetField("data", bf)
            Dim data = inf.GetValue(autoSource)
            inf = GetType(ArrayList).GetField("_items", bf)
            _RawWords.Be(inf.GetValue(data))
            Parse("")
         End Sub

         'figure out _FirstMatchPos, _LastMatchPos, FirstbestMatch, ValidInputLength, _DecisionColumn, SelectionStart
         Public Sub Parse(txt As String)
            _FirstMatchPos = FindBestMatch(txt) ' first cut - possibly incorrect, on invalid input
            FirstBestMatch = Words(_FirstMatchPos)
            ValidInputLength = GetDivergence(txt, FirstBestMatch, 0)
            If ValidInputLength < txt.Length AndAlso _FirstMatchPos > 0 Then 'signals invalid input
               'depending on the sort-order of the first invalid char FindBestMatch() may have retrieved the position **after** the option-range
               Dim div2 = GetDivergence(txt, Words(_FirstMatchPos - 1), 0)
               If div2 < ValidInputLength Then
                  _LastMatchPos = FindBestMatch(txt.Substring(0, ValidInputLength) & Char.MaxValue) - 1
               Else
                  '_FirstMatchPos actually incorrect, and contains the position, _LastMatchPos should have. Make up that fault
                  _LastMatchPos = _FirstMatchPos - 1
                  ValidInputLength = div2
                  _FirstMatchPos = FindBestMatch(txt.Substring(0, ValidInputLength))
                  FirstBestMatch = Words(_FirstMatchPos)
               End If
            Else
               _LastMatchPos = FindBestMatch(txt & Char.MaxValue) - 1 'Position of the last word which fits to ValidInputLength
            End If
            _DecisionColumn = GetDivergence(FirstBestMatch, Words(_LastMatchPos), ValidInputLength)
            'SelectionStart is proposal - can be changed by the caller
            SelectionStart = If(ValidInputLength >= txt.Length AndAlso WindForward, _DecisionColumn, ValidInputLength)
         End Sub

         Public Function GetNextValidKeys() As String
            If SelectionStart = FirstBestMatch.Length Then Return "><"
            If SelectionStart < _DecisionColumn Then Return ">".And(FirstBestMatch(SelectionStart), "<")
            Dim avChars As New List(Of Char)
            Dim c = Char.MinValue
            'only on SelectionStart = _DecisionColumn several Chars are available.
            'loop the option-range and collect the chars at _DecisionColumn distinct
            For i = _FirstMatchPos To _LastMatchPos
               If Char.ToUpper(Words(i)(_DecisionColumn)) <> c Then
                  c = Words(i)(_DecisionColumn)
                  avChars.Add(c)
                  c = Char.ToUpper(c)
               End If
            Next
            Return ">".And(String.Concat(avChars), "<")
         End Function

         Private Function Words(pos As Integer) As String
            Return DirectCast(_RawWords(pos), String)
         End Function

         Private Function GetDivergence(s0 As String, s1 As String, start As Integer) As Integer
            'Caution!! Exception if s0 is longer than s1!
            For i = start To s0.Length - 1
               If Char.ToUpper(s0(i)) <> Char.ToUpper(s1(i)) Then Return i
            Next
            Return s0.Length
         End Function

         Private Function FindBestMatch(txt As String) As Integer
            Dim i = Array.BinarySearch(_RawWords, txt, StringComparer.OrdinalIgnoreCase)
            Return If(i < 0, Not i, i)
         End Function

      End Class


   End Class


End Namespace
